]> git.ipfire.org Git - thirdparty/git.git/blame - t/perf/perf-lib.sh
t/perf: export variable used in other blocks
[thirdparty/git.git] / t / perf / perf-lib.sh
CommitLineData
c74c7203
JN
1# Performance testing framework. Each perf script starts much like
2# a normal test script, except it sources this library instead of
3# test-lib.sh. See t/perf/README for documentation.
342e9ef2
TR
4#
5# Copyright (c) 2011 Thomas Rast
6#
7# This program is free software: you can redistribute it and/or modify
8# it under the terms of the GNU General Public License as published by
9# the Free Software Foundation, either version 2 of the License, or
10# (at your option) any later version.
11#
12# This program is distributed in the hope that it will be useful,
13# but WITHOUT ANY WARRANTY; without even the implied warranty of
14# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
15# GNU General Public License for more details.
16#
17# You should have received a copy of the GNU General Public License
18# along with this program. If not, see http://www.gnu.org/licenses/ .
19
20# do the --tee work early; it otherwise confuses our careful
21# GIT_BUILD_DIR mangling
22case "$GIT_TEST_TEE_STARTED, $* " in
23done,*)
24 # do not redirect again
25 ;;
26*' --tee '*|*' --va'*)
27 mkdir -p test-results
28 BASE=test-results/$(basename "$0" .sh)
29 (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
30 echo $? > $BASE.exit) | tee $BASE.out
31 test "$(cat $BASE.exit)" = 0
32 exit
33 ;;
34esac
35
36TEST_DIRECTORY=$(pwd)/..
37TEST_OUTPUT_DIRECTORY=$(pwd)
38if test -z "$GIT_TEST_INSTALLED"; then
39 perf_results_prefix=
40else
41 perf_results_prefix=$(printf "%s" "${GIT_TEST_INSTALLED%/bin-wrappers}" | tr -c "[a-zA-Z0-9]" "[_*]")"."
42 # make the tested dir absolute
43 GIT_TEST_INSTALLED=$(cd "$GIT_TEST_INSTALLED" && pwd)
44fi
45
46TEST_NO_CREATE_REPO=t
ee1431bf 47TEST_NO_MALLOC_CHECK=t
342e9ef2
TR
48
49. ../test-lib.sh
50
561ae067
TR
51# Variables from test-lib that are normally internal to the tests; we
52# need to export them for test_perf subshells
53export TEST_DIRECTORY TRASH_DIRECTORY GIT_BUILD_DIR GIT_TEST_CMP
54
1a0962de
JK
55MODERN_GIT=$GIT_BUILD_DIR/bin-wrappers/git
56export MODERN_GIT
57
342e9ef2
TR
58perf_results_dir=$TEST_OUTPUT_DIRECTORY/test-results
59mkdir -p "$perf_results_dir"
60rm -f "$perf_results_dir"/$(basename "$0" .sh).subtests
61
62if test -z "$GIT_PERF_REPEAT_COUNT"; then
63 GIT_PERF_REPEAT_COUNT=3
64fi
65die_if_build_dir_not_repo () {
66 if ! ( cd "$TEST_DIRECTORY/.." &&
67 git rev-parse --build-dir >/dev/null 2>&1 ); then
68 error "No $1 defined, and your build directory is not a repo"
69 fi
70}
71
72if test -z "$GIT_PERF_REPO"; then
73 die_if_build_dir_not_repo '$GIT_PERF_REPO'
74 GIT_PERF_REPO=$TEST_DIRECTORY/..
75fi
76if test -z "$GIT_PERF_LARGE_REPO"; then
77 die_if_build_dir_not_repo '$GIT_PERF_LARGE_REPO'
78 GIT_PERF_LARGE_REPO=$TEST_DIRECTORY/..
79fi
80
81test_perf_create_repo_from () {
82 test "$#" = 2 ||
83 error "bug in the test script: not 2 parameters to test-create-repo"
84 repo="$1"
85 source="$2"
7501b592 86 source_git="$(git -C "$source" rev-parse --git-dir)"
1a0962de 87 objects_dir="$("$MODERN_GIT" -C "$source" rev-parse --git-path objects)"
342e9ef2
TR
88 mkdir -p "$repo/.git"
89 (
e2522f2a 90 cd "$source" &&
7501b592
JS
91 { cp -Rl "$objects_dir" "$repo/.git/" 2>/dev/null ||
92 cp -R "$objects_dir" "$repo/.git/"; } &&
342e9ef2
TR
93 for stuff in "$source_git"/*; do
94 case "$stuff" in
7501b592 95 */objects|*/hooks|*/config|*/commondir)
342e9ef2
TR
96 ;;
97 *)
7501b592 98 cp -R "$stuff" "$repo/.git/" || exit 1
342e9ef2
TR
99 ;;
100 esac
e2522f2a
RS
101 done
102 ) &&
103 (
7501b592 104 cd "$repo" &&
fd9dbdfb
JS
105 git init -q && {
106 test_have_prereq SYMLINKS ||
107 git config core.symlinks false
108 } &&
342e9ef2
TR
109 mv .git/hooks .git/hooks-disabled 2>/dev/null
110 ) || error "failed to copy repository '$source' to '$repo'"
111}
112
113# call at least one of these to establish an appropriately-sized repository
114test_perf_default_repo () {
115 test_perf_create_repo_from "${1:-$TRASH_DIRECTORY}" "$GIT_PERF_REPO"
116}
117test_perf_large_repo () {
118 if test "$GIT_PERF_LARGE_REPO" = "$GIT_BUILD_DIR"; then
119 echo "warning: \$GIT_PERF_LARGE_REPO is \$GIT_BUILD_DIR." >&2
120 echo "warning: This will work, but may not be a sufficiently large repo" >&2
121 echo "warning: for representative measurements." >&2
122 fi
123 test_perf_create_repo_from "${1:-$TRASH_DIRECTORY}" "$GIT_PERF_LARGE_REPO"
124}
125test_checkout_worktree () {
126 git checkout-index -u -a ||
127 error "git checkout-index failed"
128}
129
130# Performance tests should never fail. If they do, stop immediately
131immediate=t
132
e3efa94b
JS
133# Perf tests require GNU time
134case "$(uname -s)" in Darwin) GTIME="${GTIME:-gtime}";; esac
135GTIME="${GTIME:-/usr/bin/time}"
136
342e9ef2
TR
137test_run_perf_ () {
138 test_cleanup=:
139 test_export_="test_cleanup"
140 export test_cleanup test_export_
e3efa94b 141 "$GTIME" -f "%E %U %S" -o test_time.$i "$SHELL" -c '
1cbc3240 142. '"$TEST_DIRECTORY"/test-lib-functions.sh'
342e9ef2
TR
143test_export () {
144 [ $# != 0 ] || return 0
145 test_export_="$test_export_\\|$1"
146 shift
147 test_export "$@"
148}
149'"$1"'
150ret=$?
151set | sed -n "s'"/'/'\\\\''/g"';s/^\\($test_export_\\)/export '"'&'"'/p" >test_vars
152exit $ret' >&3 2>&4
153 eval_ret=$?
154
155 if test $eval_ret = 0 || test -n "$expecting_failure"
156 then
157 test_eval_ "$test_cleanup"
158 . ./test_vars || error "failed to load updated environment"
159 fi
160 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
161 echo ""
162 fi
163 return "$eval_ret"
164}
165
166
167test_perf () {
62a23c9f 168 test_start_
342e9ef2
TR
169 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
170 test "$#" = 2 ||
171 error "bug in the test script: not 2 or 3 parameters to test-expect-success"
172 export test_prereq
173 if ! test_skip "$@"
174 then
175 base=$(basename "$0" .sh)
176 echo "$test_count" >>"$perf_results_dir"/$base.subtests
177 echo "$1" >"$perf_results_dir"/$base.$test_count.descr
178 if test -z "$verbose"; then
19c3c5fd 179 printf "%s" "perf $test_count - $1:"
342e9ef2
TR
180 else
181 echo "perf $test_count - $1:"
182 fi
d17cf5f3 183 for i in $(test_seq 1 $GIT_PERF_REPEAT_COUNT); do
342e9ef2
TR
184 say >&3 "running: $2"
185 if test_run_perf_ "$2"
186 then
187 if test -z "$verbose"; then
19c3c5fd 188 printf " %s" "$i"
342e9ef2
TR
189 else
190 echo "* timing run $i/$GIT_PERF_REPEAT_COUNT:"
191 fi
192 else
193 test -z "$verbose" && echo
194 test_failure_ "$@"
195 break
196 fi
197 done
198 if test -z "$verbose"; then
199 echo " ok"
200 else
201 test_ok_ "$1"
202 fi
203 base="$perf_results_dir"/"$perf_results_prefix$(basename "$0" .sh)"."$test_count"
204 "$TEST_DIRECTORY"/perf/min_time.perl test_time.* >"$base".times
205 fi
62a23c9f 206 test_finish_
342e9ef2
TR
207}
208
209# We extend test_done to print timings at the end (./run disables this
210# and does it after running everything)
211test_at_end_hook_ () {
212 if test -z "$GIT_PERF_AGGREGATING_LATER"; then
213 ( cd "$TEST_DIRECTORY"/perf && ./aggregate.perl $(basename "$0") )
214 fi
215}
216
217test_export () {
218 export "$@"
219}